SIMPLE_ANIMAL_DEFINITIONS["running_jsonic"] = {
--[TRICK_BEHIND] = {A}, -- Trick afterimages play "A" as directly behind sprite for some reason
  ["tricking"] = {B, C, D, E}, --Trick after images also show B, C, D, and E sprites for rotation, so might as well make trick B-E anyway (If this is your walking animation trick afterimages will show walking)
  ["dash"] = {B, C, D, E},
  ["roll"] = {B, C, D, E},
  ["glide"] = {F},  
--[CHARACTER_SELECT] = {G}, -- G and J get used for the character select animation.
  ["goal"] = {H},
  ["spin"] = {I},
  ["standing"] = {J}, -- Also character select but can double as standing animation. :P
  ["walking"] = {K, L, M, N, O, P, Q, R},
  ["reverse"] = {R, Q, P, O, N, M, L, K},
  ["running"] = {S, T, U, V, W, X},
  ["ascend"] = {Y},
  ["descend"] = {Z, Z, Z+1, Z+1},
  ["squish"] = {Z+2},
  ["pain"] = {Z+3},
  ["superrun"] = {Z+4, Z+4, Z+5, Z+5},
  ["win"] = {Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6, Z+6,
             Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7, Z+7},
  ["drifting"] = {Z+8, Z+9, Z+10}

}

function SIMPLE_ANIMAL_HELPERS.isGliding(mobj)
  return mobj.paragliding
end

function SIMPLE_ANIMAL_HOOKS.running_jsonic_hook(mobj, sequences)
  if mobj.skin == "running_jsonic"
    local helpers = _G["SIMPLE_ANIMAL_HELPERS"]
	
	  local halfspeed = helpers.isJunioSonicWalkSpeedMultiplied(mobj, FRACUNIT/2)
	  local quarterspeed = helpers.isJunioSonicWalkSpeedMultiplied(mobj, FRACUNIT/4)

    if (sequences[1] == "goal")
      return
	elseif helpers.isPained(mobj)
	  return "pain"
	elseif helpers.isCountdownCharging(mobj)
      return "drifting"
	elseif helpers.isNoSpeed(mobj) and not (helpers.isFinished(mobj) or helpers.isAirborne(mobj) or helpers.isPained(mobj) or helpers.isSpinning(mobj) or helpers.isSquished(mobj))
	  return "standing"
	elseif helpers.isDropDashing(mobj)
      return "dash"
	elseif helpers.isTrickFailed(mobj)
	  return "spin"
	elseif helpers.isSpinning(mobj)
	  return "spin"
	elseif helpers.isTricking(mobj)
	  return "dash"
	elseif helpers.isJunioSonicRunSpeed(mobj) and not (helpers.isDriftingLeft(mobj) or helpers.isDriftingRight(mobj) or helpers.isPained(mobj) or helpers.isSuper(mobj) or helpers.isAirborne(mobj))
	  return "running"
	elseif helpers.isJunioSonicTopSpeed(mobj) and not (helpers.isDriftingLeft(mobj) or helpers.isDriftingRight(mobj) or helpers.isPained(mobj) or helpers.isSuper(mobj) or helpers.isAirborne(mobj))
	  return "running"
	elseif (helpers.isJunioSonicRunSpeed(mobj) or helpers.isJunioSonicTopSpeed(mobj)) and helpers.isSuper(mobj) and not (helpers.isDriftingLeft(mobj) or helpers.isDriftingRight(mobj) or helpers.isPained(mobj) or helpers.isAirborne(mobj))
	  return "superrun"
	elseif (helpers.isDriftingLeft(mobj) or helpers.isDriftingRight(mobj)) and not (helpers.isAirborne(mobj) or helpers.isPained(mobj))
      return "drifting"
    elseif helpers.isFinished(mobj) and helpers.isNoSpeed(mobj) and not (helpers.isSquished(mobj) or helpers.isSpinning(mobj) or helpers.isPained(mobj) or helpers.isAirborne(mobj))
		if helpers.isLose(mobj)
      return "standing"
		elseif helpers.isWin(mobj)
	  return "win"
		else
	  return "standing"
		end
elseif helpers.isJunioSonicWalkSpeed(mobj) and not (helpers.isAirborne(mobj) or helpers.isDriftingLeft(mobj) or helpers.isDriftingRight(mobj) or helpers.isPained(mobj)) then
    if helpers.isMovingForward(mobj) then
        if ((not quarterspeed and leveltime % 4 < 3) or (quarterspeed and not halfspeed) and leveltime % 2 < 1) then
            mobj.Simple_AnimaL_timer = mobj.Simple_AnimaL_timer - 1
        end
        return "walking"
    elseif helpers.isMovingBackward(mobj) then
        if ((not quarterspeed and leveltime % 4 < 3) or (quarterspeed and not halfspeed) and leveltime % 2 < 1) then
            mobj.Simple_AnimaL_timer = mobj.Simple_AnimaL_timer - 1
        end
        return "reverse"
    end
	  elseif helpers.isGliding(mobj)
        return "glide"
      elseif helpers.isScending(mobj)
        return "roll"
      elseif helpers.isAscending(mobj)
        return "ascend"
      elseif helpers.isDescending(mobj)
        return "descend"
      end
	end
end