SIMPLE_ANIMAL_DEFINITIONS["running_psonic"] = {
  ["roll"] = {A, A, B, C, C, D, E, E, Z+34, Z+35, Z+35, Z+36},
  ["tricking"] = {A, A, B, C, C, D, E, E, Z+34, Z+35, Z+35, Z+36}, --Trick after images also show B, C, D, and E sprites for rotation, so might as well make trick B-E anyway (If this is your walking animation trick afterimages will show walking)
  ["glide"] = {F}, 
  --[CHARACTER_SELECT] = {G}, -- G and J get used for the character select animation.
  ["goal"] = {H},
  ["spin"] = {I},
  ["standing"] = {J}, -- Also character select but can double as standing animation. :P
  ["walking"] = {K, L, M, N, O, P, Q, R},
  ["reverse"] = {R, Q, P, O, N, M, L, K},
  ["running"] = {S, T, U, V},
  ["fastrunning"] = {W, X, Y, Z},
  ["drifting"] = {Z+1, Z+2, Z+3, Z+4, Z+5, Z+6},
  ["ascend"] = {Z+7},
  ["descend"] = {Z+8},
  ["squish"] = {Z+9},
  ["pain"] = {Z+10},
  ["dash"] = {Z+11, Z+12, Z+13, Z+14, Z+15, Z+16, Z+17, Z+18}, 
  ["superglide"] = {Z+32},
  ["superspin"] = {Z+20},
  ["superstand"] = {Z+19},
  ["superwalk"] = {Z+20, Z+20, Z+21, Z+21, Z+22, Z+22, Z+23, Z+23},
  ["superreverse"] = {Z+23, Z+23, Z+22, Z+22, Z+21, Z+21, Z+20, Z+20},
  ["superrun"] = {Z+24, Z+24, Z+25, Z+25, Z+26, Z+26, Z+27, Z+27},
  ["superascend"] = {Z+28}, 
  ["superdescend"] = {Z+29},
  ["win"] = {Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30, Z+30,
             Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31, Z+31},
  ["lose"] = {Z+33}

}

function SIMPLE_ANIMAL_HELPERS.isGliding(mobj)
  return mobj.paragliding
end

function SIMPLE_ANIMAL_HOOKS.running_psonic_hook(mobj, sequences)
  if mobj.skin == "running_psonic"
    local helpers = _G["SIMPLE_ANIMAL_HELPERS"]
	
	  local halfspeed = helpers.isPointySonicWalkSpeedMultiplied(mobj, FRACUNIT/2)
	  local quarterspeed = helpers.isPointySonicWalkSpeedMultiplied(mobj, FRACUNIT/4)

    if (sequences[1] == "goal")
      return
	elseif helpers.isCountdownCharging(mobj)
      return "drifting"
	elseif helpers.isNoSpeed(mobj) and not (helpers.isFinished(mobj) or helpers.isAirborne(mobj) or helpers.isPained(mobj) or helpers.isSpinning(mobj) or helpers.isSuper(mobj) or helpers.isSquished(mobj))
	  return "standing"
	elseif helpers.isDropDashing(mobj)
      return "dash"
	elseif helpers.isTrickFailed(mobj)
	  return "spin"
	elseif helpers.isSpinning(mobj)
	  return "spin"
	elseif helpers.isTricking(mobj)
	  return "dash"
	elseif helpers.isPointySonicRunSpeed(mobj) and not (helpers.isDriftingLeft(mobj) or helpers.isDriftingRight(mobj) or helpers.isPained(mobj) or helpers.isSuper(mobj) or helpers.isAirborne(mobj))
	  return "running"
	elseif helpers.isPointySonicTopSpeed(mobj) and not (helpers.isDriftingLeft(mobj) or helpers.isDriftingRight(mobj) or helpers.isPained(mobj) or helpers.isSuper(mobj) or helpers.isAirborne(mobj))
	  return "fastrunning"
	elseif (helpers.isPointySonicRunSpeed(mobj) or helpers.isPointySonicTopSpeed(mobj)) and helpers.isSuper(mobj) and not (helpers.isDriftingLeft(mobj) or helpers.isDriftingRight(mobj) or helpers.isPained(mobj) or helpers.isAirborne(mobj))
	  return "superrun"
	elseif helpers.isNoSpeed(mobj) and helpers.isSuper(mobj) and not (helpers.isSpinning(mobj) or helpers.isAirborne(mobj) or helpers.isPained(mobj))
	  return "superstand"
	elseif helpers.isSpinning(mobj) and helpers.isSuper(mobj)
	  return "superspin"
	elseif (helpers.isDriftingLeft(mobj) or helpers.isDriftingRight(mobj)) and not (helpers.isAirborne(mobj) or helpers.isPained(mobj))
      return "drifting"
    elseif helpers.isFinished(mobj) and helpers.isNoSpeed(mobj) and not (helpers.isSquished(mobj) or helpers.isSpinning(mobj) or helpers.isPained(mobj) or helpers.isAirborne(mobj) or helpers.isSuper(mobj))
		if helpers.isLose(mobj)
      return "lose"
		elseif helpers.isWin(mobj)
	  return "win"
		else
	  return "standing"
		end
   elseif helpers.isAirborne(mobj) and not helpers.isTricking(mobj) and not (helpers.isSquished(mobj) or helpers.isSpinning(mobj) or helpers.isPained(mobj) or helpers.isDropDashing(mobj) or helpers.isPained(mobj))
      if helpers.isGliding(mobj) and helpers.isSuper(mobj)
		return "superglide"
	  elseif helpers.isGliding(mobj) and not helpers.isSuper(mobj)
        return "glide"
      elseif helpers.isScending(mobj)
        return "roll"
      elseif helpers.isAscending(mobj) and helpers.isSuper(mobj)
        return "superascend"
      elseif helpers.isAscending(mobj) and not helpers.isSuper(mobj)
        return "ascend"
      elseif helpers.isDescending(mobj) and helpers.isSuper(mobj)
        return "superdescend"
      else
        return "descend"
      end


elseif helpers.isPointySonicWalkSpeed(mobj) and not (helpers.isSuper(mobj) or helpers.isAirborne(mobj) or helpers.isDriftingLeft(mobj) or helpers.isDriftingRight(mobj) or helpers.isPained(mobj)) then
    if helpers.isMovingForward(mobj) then
        if ((not quarterspeed and leveltime % 4 < 3) or (quarterspeed and not halfspeed) and leveltime % 2 < 1) then
            mobj.Simple_AnimaL_timer = mobj.Simple_AnimaL_timer - 1
        end
        return "walking"
    elseif helpers.isMovingBackward(mobj) then
        if ((not quarterspeed and leveltime % 4 < 3) or (quarterspeed and not halfspeed) and leveltime % 2 < 1) then
            mobj.Simple_AnimaL_timer = mobj.Simple_AnimaL_timer - 1
        end
        return "reverse"
    end

elseif helpers.isPointySonicWalkSpeed(mobj) and helpers.isSuper(mobj) and not (helpers.isAirborne(mobj) or helpers.isDriftingLeft(mobj) or helpers.isDriftingRight(mobj) or helpers.isPained(mobj)) then
    if helpers.isMovingForward(mobj) then
        if ((not quarterspeed and leveltime % 4 < 3) or (quarterspeed and not halfspeed) and leveltime % 2 < 1) then
            mobj.Simple_AnimaL_timer = mobj.Simple_AnimaL_timer - 1
        end
        return "superwalk"
    elseif helpers.isMovingBackward(mobj) then
        if ((not quarterspeed and leveltime % 4 < 3) or (quarterspeed and not halfspeed) and leveltime % 2 < 1) then
            mobj.Simple_AnimaL_timer = mobj.Simple_AnimaL_timer - 1
        end
        return "superreverse"
    end
	end
end
end